您的位置:首页 > 其它

292. Nim Game

2016-09-03 12:05 267 查看
原题链接:https://leetcode.com/problems/nim-game/

原题:

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

题意:这是关于博弈论中的Nim游戏模型的题,就是你和你的朋友每人每次可以拿1~3块石头,现在有n块石头,你是先手,两人轮流拿取石头,恰好拿完石头的那个人赢得比赛,那么n为多少时,你一定能赢得比赛?比如,n==4时,你必输。

解题思路:

当 n==4时,你拿取1~3块,都必然输;

当n==5时,你拿取1块,让你的朋友面对必然输的情况;

当n==6时,你拿取2块,让你的朋友面对必然输的情况;

当n==7时,你拿取3块,让你的朋友面对必然输的情况;

当n==8时,你拿取1~3块,你的朋友则能拿取恰当的石头数使你面对必然输的情况;

所以容易知道,当n%4==0的时候,你必然输,反之,你必然赢。

所以,ac代码如下:

class Solution {
public:
bool canWinNim(int n) {
return n%4!=0;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode Nim游戏